#
# spec file for package mysql (Version 4.1.7)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#
# Modified by: Maik Broemme <mbroemme@plusserver.de>

# neededforbuild  gcc-c++ libstdc++-devel lthreads perl tcpd
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib gcc gcc-c++ gdbm gettext libstdc++-devel libtool perl rpm tcpd

Name:		mysql
License:	GPL, Other License(s), see package
Group:		Productivity/Databases/Servers
Requires:	mysql-client
Autoreqprov:	on
Version:	4.1.7
Release:	1.intergenia
URL:		http://www.mysql.com
Packager:	Maik Broemme <mbroemme@plusserver.de>
Vendor:		Intergenia AG
Summary:	A true multi-user, multi-threaded SQL database server
PreReq:		/usr/sbin/useradd fileutils %install_info_prereq %fillup_prereq %insserv_prereq
Source:		http://www.mysql.com/Downloads/MySQL-4.1/%{name}-%{version}.tar.gz
Source1:	rc.mysql
Source2:	README.SuSE
# manual can be found in http://mysql.linux.cz/Downloads/Manual/
Source3:	manual.pdf-2004-11-01.bz2
Patch:		%{name}-%{version}-install-db.intergenia.patch
Patch3:		%{name}-%{version}-log-rotate.patch
Patch4:		%{name}-%{version}-cnf.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
BuildRequires:	gcc-c++ >= 3.3.1, libstdc++-devel >= 3.3.1, perl >= 5.8.1, tcpd >= 7.6

%description
SQL is the most popular database language in the world. MySQL is a
client/server implementation that consists of a server daemon mysqld
and many different client programs and libraries.

The main goals of MySQL are speed, robustness and ease of use. MySQL
was originally developed because the developers at TcX needed a SQL
server that could handle very large databases an order of magnitude
faster than what any database vendor could offer to them. They have now
been using MySQL since 1996 in an environment with more than 40
databases containing 10,000 tables, of which more than 500 have more
than 7 million rows. This is about 100 gigabytes of mission-critical
data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many years. While
MySQL is still in development, it already offers a rich and highly
useful function set.

The official way to pronounce MySQL is "My Ess Que Ell" (Not
MY-SEQUEL).

This package does only contain the server-side programs.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%package devel
Obsoletes:    mysqldev
Provides:     mysqldev
Requires:     mysql-client mysql-shared
License:      GPL, Other License(s), see package
Summary:      MySQL - Development header files and libraries
URL:          http://www.mysql.com
Packager:     Maik Broemme <mbroemme@plusserver.de>
Vendor:       Intergenia AG
Group:        Development/Libraries/C and C++
Autoreqprov:  on

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%package client
Obsoletes:    mysqclnt
Provides:     mysqclnt
License:      GPL, Other License(s), see package
Summary:      MySQL - Client
URL:          http://www.mysql.com
Packager:     Maik Broemme <mbroemme@plusserver.de>
Vendor:       Intergenia AG
Group:        Productivity/Databases/Clients
Autoreqprov:  on

%description client
This package contains the standard MySQL clients.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%package bench
Obsoletes:    mysqbnch
Provides:     mysqbnch
Requires:     mysql-client perl-Msql-Mysql-modules
License:      LGPL
Summary:      MySQL - Benchmarks
URL:          http://www.mysql.com
Packager:     Maik Broemme <mbroemme@plusserver.de>
Vendor:       Intergenia AG
Group:        Productivity/Databases/Tools
Autoreqprov:  on

%description bench
This package contains MySQL benchmark scripts and data.

If you like to run these database benchmarks, start the script
"run-all-tests" in the directory /usr/share/sql-bench after starting
MySQL.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%package shared
Obsoletes:    mysqllib
Provides:     mysqllib
Summary:      MySQL Shared Libraries
License:      GPL, Other License(s), see package
URL:          http://www.mysql.com
Packager:     Maik Broemme <mbroemme@plusserver.de>
Vendor:       Intergenia AG
Group:        Development/Libraries/Other
Autoreqprov:  on

%description shared
This package contains the shared libraries (.so) which certain
languages and applications need to dynamically load and use MySQL.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%package Max
Summary:      MySQL - server with Berkeley DB
License:      GPL, Other License(s), see package
URL:          http://www.mysql.com
Packager:     Maik Broemme <mbroemme@plusserver.de>
Vendor:       Intergenia AG
Group:        Productivity/Databases/Servers
Requires:     mysql
Autoreqprov:  on

%description Max
An optional MySQL server binary that supports features like
transactional tables. To make use of these features, just install this
package in addition to the MySQL package.



Authors:
--------
    Michael Widenius <monty@mysql.com>
    David Axmark <davida@mysql.com>

%prep
%setup -q -n %{name}-%{version}
cp %{S:3} Docs/manual.pdf.bz2
bunzip2 Docs/manual.pdf.bz2
%patch -p1
%patch3
%patch4

%build
%{?suse_update_config:%{suse_update_config}}
libtoolize --copy --force
aclocal
autoconf
automake
# Generate file reservedwords.texi from sql/lex.h
echo "@multitable @columnfractions .25 .25 .25 .25" >Docs/reservedwords.texi
x="@item"; n=4; a=""
for i in `sed -n '/symbols\[] *=/,/};/s=.*"\([[:alpha:]_]*\)".*=\1=p' sql/lex.h`; do
  a="$a$x @code{$i}"
  x=" @tab"
  let --n || { echo $a >>Docs/reservedwords.texi; a=""; x="@item"; n=4; }
done
echo $a >>Docs/reservedwords.texi
echo "@end multitable" >>Docs/reservedwords.texi
# For some platforms the berkeley DB backend does not work.
export BERKELEY="with"
%ifarch ppc ppc64 s390 s390x mips alpha x86_64 sparc hppa
export BERKELEY="without"
%endif
# Make the compile a function, since we have to do it twice
BuildMySQL() {
# The --enable-assembler simply does nothing on systems that do not
# support assembler speedups.
export CFLAGS="$RPM_OPT_FLAGS -DPIC -fPIC"
export CXXFLAGS="$RPM_OPT_FLAGS \
				-felide-constructors \
				-fno-exceptions \
				-fno-rtti \
				-fPIC -DPIC"
./configure \
	$* \
	--enable-assembler \
	--enable-large-files \
	--infodir=%{_infodir} \
	--libdir=%{_libdir} \
	--libexecdir=/usr/sbin \
	--localstatedir=/var/lib/mysql \
	--mandir=%{_mandir} \
	--prefix=%{_prefix} \
	--sysconfdir=/etc \
	--with-mysqld-user=mysql \
	--without-debug \
	--datadir=/usr/share \
	--includedir=/usr/include \
	--with-extra-charsets=complex \
	--with-unix-socket-path=/var/lib/mysql/mysql.sock \
	--with-libwrap
	# Add this for more debugging support
	# --with-debug
	# Add this for MyISAM RAID support:
	# --with-raid
	# benchdir does not fit in above model. Fix when we make a separate package
%ifarch s390 s390x
	# The atomic stuff doesn't work the way mySQL wants to use it
	# on s390, and s390x, so we have to make sure, that pthreads
	# mutexes are being used.
	ex config.h +/HAVE_ATOMIC_ADD/d +/HAVE_ATOMIC_SUB/d +w +q
%endif
	make benchdir=$RPM_BUILD_ROOT/usr/share/sql-bench
}
# Build the shared libraries and mysqld-max
BuildMySQL "--enable-shared \
			--enable-thread-safe-client \
			--${BERKELEY}-berkeley-db \
			--with-innodb \
			--with-mysqld-ldflags=-static --without-extra-tools \
			--with-server-suffix=-Max"
# Clean up the BuildRoot first
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
install -d -m 755 $RPM_BUILD_ROOT
# Save shared libraries and mysqld-max
mv sql/mysqld sql/mysqld-max
nm --numeric-sort sql/mysqld-max > sql/mysqld-max.sym
(cd libmysql/.libs; tar cf $RPM_BUILD_ROOT/shared-libs.tar *.so* *.lai)
(cd libmysql_r/.libs; tar rf $RPM_BUILD_ROOT/shared-libs.tar *.so* *.lai)
# Save manual to avoid rebuilding
mv Docs/manual.ps Docs/manual.ps.save
make clean
mv Docs/manual.ps.save Docs/manual.ps
# Now build the "normal" mysqld
BuildMySQL "--disable-shared \
			--enable-thread-safe-client \
			--with-mysqld-ldflags=-static \
			--with-client-ldflags=-static \
			--without-berkeley-db --with-extra-tools --without-innodb"
nm --numeric-sort sql/mysqld > sql/mysqld.sym

%install
/usr/sbin/useradd -r -o -g daemon -u 60 -s /bin/false -c "MySQL database admin" -d /var/lib/mysql mysql 2> /dev/null || :
# Create directory structure
DOC="Docs/INSTALL-BINARY INSTALL-SOURCE README"
DOCDIR=$RPM_BUILD_ROOT/%{_defaultdocdir}/mysql
install -d -m 755 ${DOCDIR}/cnf
install -d -m 755 ${DOCDIR}/data
install -d -m 755 ${DOCDIR}/data/mysql
install -d -m 755 ${DOCDIR}/html
install -d -m 755 $RPM_BUILD_ROOT/usr/share/sql-bench
install -d -m 755 $RPM_BUILD_ROOT/etc/logrotate.d
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
install -d -m 755 $RPM_BUILD_ROOT/etc/init.d
install -d -m 755 $RPM_BUILD_ROOT/usr/sbin
install -d -m 755 $RPM_BUILD_ROOT/var/lib/mysql
make install DESTDIR=$RPM_BUILD_ROOT benchdir_root=/usr/share/
# Install shared libraries
(cd $RPM_BUILD_ROOT/usr/%_lib; tar xf $RPM_BUILD_ROOT/shared-libs.tar "*.so*")
# install saved mysqld-max
install -m 755 sql/mysqld-max $RPM_BUILD_ROOT/usr/sbin/mysqld-max
# install symbol files ( for stack trace resolution)
install -m 644 sql/mysqld-max.sym $RPM_BUILD_ROOT%{_libdir}/mysql/mysqld-max.sym
install -m 644 sql/mysqld.sym $RPM_BUILD_ROOT%{_libdir}/mysql/mysqld.sym
# Preserve *.la from shared build
(cd $RPM_BUILD_ROOT%{_libdir}/mysql
 tar xf $RPM_BUILD_ROOT/shared-libs.tar "*.lai"
 rm $RPM_BUILD_ROOT/shared-libs.tar
 for f in *.lai; do mv $f ${f%i}; done
 cd ..; LIBCLIENT=../`ls libmysqlclient.so.*.*.*`
 for f in libmysqlclient.so*; do ln -fs $LIBCLIENT mysql/$f; done)
install -m 644 support-files/mysql-log-rotate $RPM_BUILD_ROOT/etc/logrotate.d/mysql
install -m 600 support-files/my-medium.cnf $RPM_BUILD_ROOT/etc/my.cnf
install -m 640 scripts/mysqlaccess.conf $RPM_BUILD_ROOT/etc/mysqlaccess.conf
install -m 644 ${DOC} ${DOCDIR}
install -m 644 %{SOURCE2} ${DOCDIR}
install -m 644 Docs/manual.pdf ${DOCDIR}
install -m 644 Docs/manual.txt ${DOCDIR}
install -m 644 Docs/manual.html ${DOCDIR}/html
install -m 644 Docs/manual_toc.html ${DOCDIR}/html
rm -f ${DOCDIR}/html/index.html
ln -s ./manual_toc.html ${DOCDIR}/html/index.html
install -m 644 support-files/my-*.cnf ${DOCDIR}/cnf
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d/mysql
rm -f $RPM_BUILD_ROOT/sbin/rcmysql
ln -s ../../etc/init.d/mysql $RPM_BUILD_ROOT/usr/sbin/rcmysql
#install -m 755 scripts/mysql_install_db ${DOCDIR}
rm -f $RPM_BUILD_ROOT/usr/bin/make_win_src_distribution
rm -f $RPM_BUILD_ROOT/usr/bin/make_win_binary_distribution

%pre
/usr/sbin/useradd -r -o -g daemon -u 60 -s /bin/false -c "MySQL database admin" -d /var/lib/mysql mysql 2> /dev/null || :
dbfile=var/mysql/mysql/db.ISM
olddir=var/mysql
newdir=var/lib/mysql
# Do the database files still belong to root (very old installation)?
# Change ownerships and notify user
if [ -O $dbfile ]
then
chown -Rv mysql:daemon var/mysql/
mkdir -p var/adm/notify/messages
echo 'The previously installed version of MySQL ran as user "root". Due
to security reasons, MySQL will now be started as user "mysql". The
ownerships of your existing database files have been adjusted accordingly.
If you are upgrading from a MySQL version <= 3.22.10 you should also
run the script /usr/bin/mysql_fix_privilege_tables. Otherwise you will
not be able to use the new GRANT command!
--------------------------------------------------------------------------
German Translation/Deutsche Fassung:
Die vorher installierte Version von MySQL lief unter der Benutzerkennung
"root". Aus Sicherheitsgrnden wird MySQL nun unter der Benutzerkennung
"mysql" gestartet. Die Ownerships Ihrer bestehenden Datenbankfiles wurden
entsprechend umgendert.
Bei einem Update von MySQL-Version <= 3.22.10 sollten Sie weiterhin
nun das Script /usr/bin/mysql_fix_privilege_tables ausfhren.
Anderenfalls knnen Sie nicht das neue "GRANT"-Kommando verwenden!' \
> var/adm/notify/messages/mysql-changes
fi
# Copy existing database files to the new location
# only if they do not exist yet!
if [ -d $olddir ] && ! [ -d $newdir ]
then
echo "Copying old database files to new location..."
cp -a $olddir $newdir || echo "Error while copying the files!"
mkdir -p var/adm/notify/messages
echo 'Starting with SuSE Linux 7.1, we moved the database files from
/var/mysql to /var/lib/mysql to better comply with the File System
Hierarchy Standard (FHS).
Your existing MySQL database files have been copied to the new location
/var/lib/mysql. If everything runs fine, you can delete the old files
below /var/mysql now.
--------------------------------------------------------------------------
German Translation/Deutsche Fassung:
Beginnend mit SuSE Linux 7.1 haben wir die MySQL Datenbanken von
/var/mysql nach /var/lib/mysql verschoben, um die Konventionen des
File System Hierarchy Standard (FHS) noch besser einzuhalten.
Ihre existierenden Datenbanken wurden in das neue Verzeichnis
/var/lib/mysql kopiert. Wenn alles wie bisher funktioniert, knnen
Sie nun die alten Dateien unter /var/mysql lschen.' \
>> var/adm/notify/messages/mysql-changes
fi

%post
%{fillup_and_insserv mysql}
%install_info --info-dir=%{_infodir} %{_infodir}/mysql.info.gz

%preun 
%stop_on_removal mysql

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/mysql.info.gz
%restart_on_update mysql
%{insserv_cleanup}

%clean
# Clear up the mess
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-, root, root)
%config %attr(-, mysql, daemon) /etc/my.cnf
%config /etc/init.d/mysql
%config /etc/logrotate.d/mysql
%doc %{_defaultdocdir}/%{name}
%doc %{_infodir}/mysql.info.gz
%doc %{_mandir}/man1/isamchk.1.gz
%doc %{_mandir}/man1/isamlog.1.gz
%doc %{_mandir}/man1/mysql_zap.1.gz
%doc %{_mandir}/man1/mysqld.1.gz
%doc %{_mandir}/man1/mysqld_multi.1.gz
%doc %{_mandir}/man1/mysqld_safe.1.gz
%doc %{_mandir}/man1/mysql_fix_privilege_tables.1.gz
/usr/bin/isamchk
/usr/bin/isamlog
/usr/bin/my_print_defaults
/usr/bin/myisamchk
/usr/bin/myisamlog
/usr/bin/myisampack
/usr/bin/mysql_convert_table_format
/usr/bin/mysql_create_system_tables
/usr/bin/mysql_fix_privilege_tables
/usr/bin/mysql_install_db
/usr/bin/mysql_setpermission
/usr/bin/mysql_zap
/usr/bin/mysqlbug
/usr/bin/mysqld_multi
/usr/bin/mysqlhotcopy
/usr/bin/mysqltest
/usr/bin/pack_isam
/usr/bin/resolve_stack_dump
/usr/bin/resolveip
/usr/bin/mysqld_safe
%{_libdir}/mysql/mysqld.sym
/usr/sbin/mysqld
/usr/sbin/rcmysql
/usr/share/mysql/
%attr(755,mysql,daemon)/var/lib/mysql
/usr/bin/mysql_secure_installation
/usr/bin/mysqldumpslow
/usr/bin/mysql_explain_log
/usr/bin/mysql_fix_extensions

%files client
%defattr(-, root, root)
%config /etc/mysqlaccess.conf
%doc %{_mandir}/man1/mysql.1.gz
%doc %{_mandir}/man1/mysqlaccess.1.gz
%doc %{_mandir}/man1/mysqladmin.1.gz
%doc %{_mandir}/man1/mysqldump.1.gz
%doc %{_mandir}/man1/mysqlshow.1.gz
%doc %{_mandir}/man1/perror.1.gz
%doc %{_mandir}/man1/replace.1.gz
/usr/bin/client_test
/usr/bin/msql2mysql
/usr/bin/mysql
/usr/bin/mysql_waitpid
/usr/bin/mysql_find_rows
/usr/bin/mysql_tzinfo_to_sql
/usr/bin/mysqlaccess
/usr/bin/mysqladmin
/usr/bin/mysqlbinlog
/usr/bin/mysqlcheck
/usr/bin/mysqldump
/usr/bin/myisam_ftdump
/usr/bin/mysqlimport
/usr/bin/mysqlshow
/usr/bin/perror
/usr/bin/replace
/usr/bin/mysql_tableinfo

%files devel
%defattr(-, root, root)
/usr/bin/comp_err
/usr/bin/mysql_config
/usr/include/mysql
%dir %{_libdir}/mysql
%{_libdir}/mysql/*.*a
%{_libdir}/libmysqlclient.so
%{_libdir}/mysql/libmysqlclient.so

%files bench
%defattr(-, root, root)
/usr/share/sql-bench
/usr/share/mysql-test
/usr/bin/mysqlmanager
/usr/bin/mysqlmanager-pwgen
/usr/bin/mysqlmanagerc

%files shared
%defattr(-, root, root)
%{_libdir}/*.so.*
%{_libdir}/mysql/*.so.*

%files Max
%defattr(-, root, root)
/usr/sbin/mysqld-max
%{_libdir}/mysql/mysqld-max.sym

%changelog -n mysql
* Wed Nov  3 2004 Maik Broemme <mbroemme@plusserver.de> 4.1.7-1.intergenia
- updated to mysql 4.1.7
